#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

struct El {
    int v;
    int i;
    int j;

    bool operator<(El other) {
        return v < other.v;
    }
};

bool comp(El lhs, El rhs) {
    return lhs < rhs;
}

vector<int> doCycle(int len, int min, int rb, vector<El>& a, long long sum, long long s) {
    vector<int> ans(1, -1);

    for (int i = min + 1; i <= rb - len + 1; ++i) {
        if (len != 1) {
            ans = doCycle(len - 1, i, rb, a, sum + a[i].v, s);
            if (ans[0] != -1) {
                ans.push_back(i);
                return ans;
            }
        } else if (sum + a[i].v == s) {
            ans[0] = i;
            return ans;
        }
    }

    return ans;
}


int main() {
    int h, w;
    cin >> h >> w;

    vector<vector<El>> a(h, vector<El>(w));

    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j].v;
            a[i][j].i = i;
            a[i][j].j = j;
        }
    }

    long long s;
    cin >> s;

    if (h == 1) {
        sort(a[0].begin(), a[0].end(), comp);
        int l = 1;
        int r = w;

        int rb = w - 1;
        while (a[0][rb].v > s) {
            rb--;
        }

        if (rb == -1) {
            cout << "NO";
            return 0;
        }

        long long sum = 0;
        int i = 0;

        for (; i <= rb; ++i) {
            sum += a[0][i].v;

            if (sum == s) {
                cout << "YES" << endl;
                cout << w - (i + 1) << endl;

                for (int k = 0; k < w; ++k) {
                    bool f = true;
                    for (int j = 0; j <= i; ++j) {
                        if (a[0][j].j == k) {
                            f = false;
                        }
                    }

                    if (f) {
                        cout << "2 " << k + 1 << endl;
                    }
                }

                return 0;
            } else if (sum > s) {
                r = i;
                break;
            }
        }

        if (i == rb + 1) {
            cout << "NO";
            return 0;
        }

        sum = 0;

        for (i = rb; i >= 0; --i) {
            sum += a[0][i].v;

            if (sum == s) {
                cout << "YES" << endl;
                cout << w - (rb - i + 1) << endl;

                for (int k = 0; k < w; ++k) {
                    bool f = true;
                    for (int j = 0; j <= rb - i; ++j) {
                        if (a[0][rb - j].j == k) {
                            f = false;
                        }
                    }

                    if (f) {
                        cout << "2 " << k + 1 << endl;
                    }
                }

                return 0;
            } else if (sum > s) {
                l = rb - i + 1;
                break;
            }
        }

        vector<int> ans;

        for (int len = l; len <= r; ++len) {
            ans = doCycle(len, -1, rb, a[0], 0, s);

            if (ans[0] != -1) {
                cout << "YES" << endl;
                cout << w - ans.size() << endl;

                for (int k = 0; k < w; ++k) {
                    bool f = true;
                    for (int i = 0; i < ans.size(); ++i) {
                        if (a[0][ans[i]].j == k) {
                            f = false;
                        }
                    }

                    if (f) {
                        cout << "2 " << k + 1 << endl;
                    }
                }

                return 0;
            }
        }

        cout << "NO";
        return 0;
    }

    return 0;
}
