#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>

using namespace std;

struct El {
    int v;
    int i;
    int j;

    bool operator<(El other) {
        return v < other.v;
    }
};

bool comp(El lhs, El rhs) {
    return lhs < rhs;
}

vector<int> doCycle(int len, int min, int rb, vector<El>& a, long long sum, long long s) {
    vector<int> ans(1, -1);

    for (int i = min + 1; i <= rb - len + 1; ++i) {
        if (len != 1) {
            if (sum + a[i].v > s) {
                continue;
            }

            ans = doCycle(len - 1, i, rb, a, sum + a[i].v, s);
            if (ans[0] != -1) {
                ans.push_back(i);
                return ans;
            }
        } else if (sum + a[i].v == s) {
            ans[0] = i;
            return ans;
        }
    }

    return ans;
}

bool solve1D(vector<El> v, long long s, int w, int horCnt) {
    sort(v.begin(), v.end(), comp);
    int l = 1;
    int r = w;

    int rb = w - 1;
    while (v[rb].v > s) {
        rb--;
    }

    if (rb == -1) {
        return false;
    }

    long long sum = 0;
    int i = 0;

    for (; i <= rb; ++i) {
        sum += v[i].v;

        if (sum == s) {
            cout << "YES" << endl;
            cout << w - (i + 1) + horCnt << endl;

            for (int k = 0; k < w; ++k) {
                bool f = true;
                for (int j = 0; j <= i; ++j) {
                    if (v[j].j == k) {
                        f = false;
                    }
                }

                if (f) {
                    cout << "2 " << k + 1 << endl;
                }
            }

            return true;
        } else if (sum > s) {
            r = i;
            break;
        }
    }

    if (i == rb + 1) {
        return false;
    }

    sum = 0;

    for (i = rb; i >= 0; --i) {
        sum += v[i].v;

        if (sum == s) {
            cout << "YES" << endl;
            cout << w - (rb - i + 1) + horCnt << endl;

            for (int k = 0; k < w; ++k) {
                bool f = true;
                for (int j = 0; j <= rb - i; ++j) {
                    if (v[rb - j].j == k) {
                        f = false;
                    }
                }

                if (f) {
                    cout << "2 " << k + 1 << endl;
                }
            }

            return true;
        } else if (sum > s) {
            l = rb - i + 1;
            break;
        }
    }

    vector<int> ans;

    for (int len = l; len <= r; ++len) {
        ans = doCycle(len, -1, rb, v, 0, s);

        if (ans[0] != -1) {
            cout << "YES" << endl;
            cout << w - ans.size() + horCnt << endl;

            for (int k = 0; k < w; ++k) {
                bool f = true;
                for (int i = 0; i < ans.size(); ++i) {
                    if (v[ans[i]].j == k) {
                        f = false;
                    }
                }

                if (f) {
                    cout << "2 " << k + 1 << endl;
                }
            }

            return true;
        }
    }

    return false;
}

int main() {
    int h, w;
    cin >> h >> w;

    vector<vector<El>> a(h, vector<El>(w));
    vector<El> vertSums(w);

    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j].v;
            a[i][j].i = i;
            a[i][j].j = j;

            vertSums[j].v += a[i][j].v;
            vertSums[j].j = j;
        }
    }

    long long s;
    cin >> s;

//    if (h == 1) {
//        if (!solve1D(a[0], s, w, 0)) {
//            cout << "NO";
//        }
//    }

    vector<int> exp2(h, 1);
    for (int i = 1; i < h; ++i) {
        exp2[i] = 2 * exp2[i - 1];
    }

    vector<El> curSums;

    for (int i = 0; i < pow(2, h) - 1; ++i) {
        curSums = vertSums;
        vector<int> ans;

        for (int j = 0; j < h; ++j) {
            if ((i & exp2[j]) == exp2[j]) {
                for (int k = 0; k < w; ++k) {
                    curSums[k].v -= a[j][k].v;
                }

                ans.push_back(j);
            }
        }

        if (solve1D(curSums, s, w, ans.size())) {
            for (int j = 0; j < ans.size(); ++j) {
                cout << "1 " << ans[j] + 1 << endl;
            }

            return 0;
        }
    }

    cout << "NO";

    return 0;
}
