#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>

using namespace std;

vector<bool> used;
vector<int> ans;
vector<vector<int>> graph;

void dfs(int v, int c) {
    used[v] = true;
    ans[v] = c;

    for (int i = 0; i < graph[v].size(); ++i) {
        if (!used[graph[v][i]]) {
            dfs(graph[v][i], c % 2 + 1);
        }
    }
}

int main() {
    int n;
    cin >> n;

    vector<pair<vector<int>, vector<int>>> v(1000000, make_pair(vector<int>(), vector<int>()));
    vector<pair<int, int>> a(n);

    used.resize(n);
    ans.resize(n);
    graph.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }

    sort(a.begin(), a.end());

    for (int i = 0; i < n; ++i) {
        vector<int> ps;

        v[a[i].first].second.push_back(a[i].second);

        for (int j = 2; j <= /*sqrt(a[i].first)*/ sqrt(a[i].first); ++j) {
            if (a[i].first % j == 0) {
                bool f = true;

                for (int k = 0; k < ps.size(); ++k) {
                    if (j % ps[k] == 0) {
                        f = false;
                        break;
                    }
                }

                if (f) {
                    ps.push_back(j);

                    if (!v[a[i].first / j].second.empty()) {
                        v[a[i].first / j].first.push_back(a[i].second);
                    }
                }
            }
        }

        for (int j = sqrt(a[i].first); j >= /*sqrt(a[i].first)*/ 2; --j) {
            if (a[i].first % j == 0) {
                bool f = true;

                for (int k = 0; k < ps.size(); ++k) {
                    if (a[i].first / j % ps[k] == 0) {
                        f = false;
                        break;
                    }
                }

                if (f) {
                    ps.push_back(a[i].first / j);

                    if (!v[a[i].first / (a[i].first / j)].second.empty()) {
                        v[a[i].first / (a[i].first / j)].first.push_back(a[i].second);
                    }
                }
            }
        }

        if (ps.empty() && !v[1].second.empty() && a[i].first != 1) {
            v[1].first.push_back(a[i].second);
        }
    }

    for (int i = 0; i < v.size(); ++i) {
        if (!v[i].second.empty()) {
            for (int j = 0; j < v[i].first.size(); ++j) {
                for (int l = 0; l < v[i].second.size(); ++l) {
                    graph[v[i].second[l]].push_back(v[i].first[j]);
                    graph[v[i].first[j]].push_back(v[i].second[l]);
                }
            }
        }
    }

//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < graph[i].size(); ++j) {
//            cout << graph[i][j] << " ";
//        }
//
//        cout << endl;
//    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, 1);
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }

    return 0;
}