#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>

using namespace std;

vector<bool> used;
vector<int> ans;
vector<vector<int>> graph;

void dfs(int v, int c) {
    used[v] = true;
    ans[v] = c;

    for (int i = 0; i < graph[v].size(); ++i) {
        if (!used[graph[v][i]]) {
            dfs(graph[v][i], c % 2 + 1);
        }
    }
}

int main() {
    int n;
    cin >> n;

    vector<pair<vector<int>, int>> v(1000000, make_pair(vector<int>(), -1));
    vector<pair<int, int>> a(n);

    used.resize(n);
    ans.resize(n);
    graph.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
//        a[i].first = i % 2 + 1;
        a[i].second = i;
    }

    sort(a.begin(), a.end());

    vector<vector<pair<int, int>>> snm;

    for (int i = 0; i < n; ++i) {
        vector<int> ps;

        if (i > 0 && a[i - 1].first == a[i].first) {
            snm[snm.size() - 1].push_back(a[i]);
            continue;
        }

        snm.push_back({ a[i] });

        v[a[i].first].second = a[i].second;

        for (int j = 2; j <= /*sqrt(a[i].first)*/ sqrt(a[i].first); ++j) {
            if (a[i].first % j == 0) {
                bool f = true;

                for (int k = 0; k < ps.size(); ++k) {
                    if (j % ps[k] == 0) {
                        f = false;
                        break;
                    }
                }

                if (f) {
                    ps.push_back(j);

                    if (v[a[i].first / j].second != -1) {
                        v[a[i].first / j].first.push_back(a[i].second);
                    }
                }
            }
        }

        for (int j = sqrt(a[i].first); j >= /*sqrt(a[i].first)*/ 2; --j) {
            if (a[i].first % j == 0) {
                bool f = true;

                for (int k = 0; k < ps.size(); ++k) {
                    if (a[i].first / j % ps[k] == 0) {
                        f = false;
                        break;
                    }
                }

                if (f) {
                    ps.push_back(a[i].first / j);

                    if (v[a[i].first / (a[i].first / j)].second != -1) {
                        v[a[i].first / (a[i].first / j)].first.push_back(a[i].second);
                    }
                }
            }
        }

        if (ps.empty() && v[1].second != -1 && a[i].first != 1) {
            v[1].first.push_back(a[i].second);
        }
    }

    for (int i = 0; i < v.size(); ++i) {
        if (v[i].second != -1) {
            for (int j = 0; j < v[i].first.size(); ++j) {
                graph[v[i].second].push_back(v[i].first[j]);
                graph[v[i].first[j]].push_back(v[i].second);
            }
        }
    }

//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < graph[i].size(); ++j) {
//            cout << graph[i][j] << " ";
//        }
//
//        cout << endl;
//    }

    for (int i = 0; i < snm.size(); ++i) {
        if (!used[snm[i][0].second]) {
            dfs(snm[i][0].second, 1);
        }
    }

    for (int i = 0; i < snm.size(); ++i) {
        for (int j = 0; j < snm[i].size(); ++j) {
            ans[snm[i][j].second] = ans[snm[i][0].second];
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }

    return 0;
}