#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

vector<int> a;
vector<int> qs;

int solveM3() {
    if (qs[0] % 3 == qs[1] % 3 && qs[0] % 3 == qs[2] % 3) {
        return min(qs[0], min(qs[2], qs[1])) / 3 + 1;
    } else {
        return 0;
    }
}

int size3(int a, int b, int c) {
    return min(a, min(b, c)) / 3 + 1;
}

int main() {
    int n, m;
    cin >> n >> m;

    a.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    sort(a.begin(), a.end());

    vector<pair<int, int>> qs1;
    qs1.push_back(make_pair(a[0], 1));

    for (int i = 1; i < n; ++i) {
        if (qs1[qs1.size() - 1].first == a[i]) {
            qs1[qs1.size() - 1].second++;
        } else {
            qs1.push_back(make_pair(a[i], 1));
        }
    }

    qs.resize(qs1.size());

    for (int i = 0; i < qs1.size(); ++i) {
        qs[i] = qs1[i].second;
    }

    if (qs.size() == 1) {
        cout << 1;
        return 0;
    } else if (qs.size() == 2) {
        if (qs[0] % 3 == 0) {
            cout << 1;
        } else {
            cout << 0;
        }

        return 0;
    } else if (qs.size() == 3) {
        cout << solveM3();
        return 0;
    }

    for (int i = 0; i < qs.size() - 2; ++i) {
        qs[i + 2] -= qs[i] % 3;
        qs[i + 1] -= qs[i] % 3;
        qs[i] -= qs[i] % 3;
    }

    for (int i = 0; i < qs.size(); ++i) {
        if (qs[i] < 0 || qs[i] % 3 != 0) {
            cout << 0;
            return 0;
        }

        qs[i] /= 3;
    }

    vector<vector<vector<int>>> dp(qs.size() - 2);

    for (int i = 0; i <= m / 3; ++i) {
        for (int j = 0; j <= m / 3; ++j) {
            dp[0][i][j] = min(qs[0], min(i, j)) + 1;
        }
    }

    for (int r = 1; r < qs.size() - 2; ++r) {
        for (int i = 0; i <= m / 3; ++i) {
            for (int j = 0; j <= m / 3; ++j) {
                for (int opQ = 0; opQ <= min(qs[r], min(i, j)); ++opQ) {
                    dp[r][i][j] += dp[r - 1][qs[r] - opQ][i - opQ];
                }
            }
        }
    }

    cout << dp[qs.size() - 3][qs[qs.size() - 2]][qs[qs.size() - 1]];

//    vector<vector<int>> dp1(qs.size() - 2, vector<int>(m + 1, 0));
//    vector<vector<int>> dp2(qs.size() - 2, vector<int>(m + 1, 0));
//
//    for (int i = 0; i <= min(qs[1].second, qs[2].second); ++i) {
//        dp2[0][i] = solveM3(i, 2);
//    }
//
//    for (int i = 1; i < qs.size() - 2; ++i) {
//        for (int opQ = qs[i].second % 3; opQ <= qs[i].second; opQ += 3) {
//            for (int q = (qs[i].second - opQ) % 3; q <= qs[i].second - opQ; q += 3) {
//                dp1[i][opQ] += dp2[i - 1][q];
//            }
//        }
//
//        for (int opQ = qs[i].second % 3; opQ <= min(qs[i].second + 1, qs[i - 1].second + 1); ++opQ) {
//            dp2[i][opQ] = dp1[i - 1]
//        }
//    }

    return 0;
}